#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h> 
#include <sys/utsname.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>

#define ERR_SOCKET -1
#define ERR_CONNECT -2

/**
 * ۥ̾ޤ10ʥɥåɽʸ󤫤IPɥ쥹ޤ
 *
 * hostent¤
 *
 * hostent {
 *	char* 	h_name 		ۥȤθ̾ 
 *	char**	h_aliases	ꥢؤΥݥ󥿤Υݥ 
 *	int	h_addrtype	ۥȥɥ쥹Υ(AF_INET | AF_INET6)
 *	int 	h_length	ɥ쥹礭 4 | 6
 *	char**	h_addr_list	IPv4 | v6ɥ쥹ؤΥݥؤΥݥ
 * };
 * 
 * @param host ۥ̾ 
 * @return host byte orderIPɥ쥹
 *                            
 */
unsigned long getAddrByName(const char* host)
{
	struct hostent *hp;
	unsigned long a;

	if (NULL != (hp = gethostbyname(host))) {
		memcpy(&a, hp->h_addr, sizeof(a));
		/**
		 * ntohlϥͥåȥΥȥ륨ǥ
		 * ӥåǥPC褷ޤ
	 	 */
		return ntohl(a);
	}

	/**
	 * inet_addr()  network byte order  32bitͥåȥХIPv4
	 * ɥ쥹֤ޤIPv6бˤϽɬפޤ
	 */
	a = inet_addr(host);

	return (-1 == (long)a)? 0 : ntohl(a);
}


/**
 * TCP饤ѤΥåȤޤ
 *
 * @param hostName ۥ̾
 * @param portNum ۥȤΥݡֹ
 * @return ³ѤTCPClientåȥǥץ
 */
int createTCPClient(const char* hostName, int portNum)
{
	struct sockaddr_in sa;
	unsigned long addr;
	int sd;

	addr = getAddrByName(hostName);  

	memset(&sa, 0, sizeof(sa));
	sa.sin_family = AF_INET;
	sa.sin_addr.s_addr = htonl(addr);
	sa.sin_port = htons((unsigned short)portNum);

	if ((sd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		return ERR_SOCKET;
	}


	if (connect(sd, (struct sockaddr*)&sa, sizeof(sa)) < 0) {
		close(sd);
		return ERR_CONNECT;
	}

	return sd;
}

/**
 * åޤ
 *
 * @param sd åȥǥץ
 * @param buf å
 * @param len Ĺ
 */
int sendMessage(int sd, char* message)
{
	return send(sd, (const char*)message, strlen(message), 0);
}


/**
 * mainؿ
 *
 *
 */
/*
int main(int argc, char** args) 
{
	const char* host = "192.168.1.12";

	int sd = createTCPClient(host, 30000);
	sendMessage(sd, "aaaaa"); 

	return EXIT_SUCCESS;
}
*/

